/******************** (C) COPYRIGHT 2013 MJX ***********************************
* File Name          : USB30_DESC_UVC.H
* Author             : MJX
* Version            : V1.00
* Date               : 2021/07/15
* Description        : USB3.0ͬģʽ豸
*******************************************************************************/


#ifndef __USB30_DESC_UVC_H__
#define __USB30_DESC_UVC_H__

#ifdef __cplusplus
extern "C" {
#endif


/******************************************************************************/
/* ͷļ */
#include "MAIN.H"                                                               /* ͷļ */

/******************************************************************************/
/* ΪUSB3.0 ͬģʽ */

/******************************************************************************/
/* USB3.0豸 */
const UINT8 USB30_Device_Desc_UVC[ ] =
{
    0x12,                                                                       /* Size of this descriptor, in bytes */
    0x01,                                                                       /* DEVICE descriptor */
    0x00,
    0x03,                                                                       /* bcdUSB */
    0xef,                                                                       /* Miscellaneous Device Class */
    0x02,                                                                       /* Common Class */
    0x01,                                                                       /* Interface Association Descriptor */
    0x09,                                                                       /* Max packet 512 */
    0x86,
    0x1A,                                                                       /* VID */
    0x04,
    0x23,                                                                       /* PID */
    DEF_PROG_VERSION,
    0x00,                                                                       /* bcdDevice */
    0x03,                                                                       /* iManufacturer */
    0x01,                                                                       /* iProduct */
    0x02,                                                                       /* iSerialNumber */
    0x01,                                                                       /* bNumConfigurations */
};

/******************************************************************************/
/* USB3.0 */
const UINT8 USB30_Config_Desc_UVC[ ] =
{

#if   1
       0x09,
       0x02,
       0x5c,
       0x01,
       0x04,
       0x01,
       0x00,
       0xa0,
       0x4b,
       /* Interface Association Descriptor */
       0x08,
       0x0b,
       0x00,
       0x02,
       0x0e,
       0x03,
       0x00,
       0x08,

       /* Standard VC Interface Descriptor */
       0x09,
       0x04,
       0x00,
       0x00,
       0x00,
       0x0e,
       0x01,
       0x00,
       0x08,
       /* Class-specific VC Interface Descriptor */
       0x0d,
       0x24,
       0x01,
       0x00,
       0x01,
       0x4d,
       0x00,
       0x00,
       0x0e,
       0x27,
       0x07,
       0x01,
       0x01,
       /* Input Terminal Descriptor (Composite) */
       0x12,
       0x24,
       0x02,
       0x01,
       0x01,
       0x02,
       0x00,
       0x00,
       0x00,
       0x00,
       0x00,
       0x00,
       0x00,
       0x00,
       0x03,
       0x00,
       0x00,
       0x00,

       0x0b,
       0x24,
       0x05,
       0x03,
       0x01,
       0x00,
       0x00,
       0x02,
       0x00,
       0x00,
       0x00,
       /* Output Terminal Descriptor */
       0x09,
       0x24,
       0x03,
       0x02,
       0x01,
       0x01,
       0x00,
       0x04,
       0x00,
       /* Extension Unit Descriptor */
       0x1a,
       0x24,
       0x06,
       0x04,
       0x5b,
       0x12,
       0x6d,
       0xc6,
       0x80,
       0x04,
       0x44,
       0x08,
       0x8c,
       0x26,
       0xb8,
       0x36,
       0x3a,
       0x84,
       0xde,
       0x63,
       0x03,
       0x01,
       0x03,
       0x01,
       0x07,
       0x00,
       /* Standard VS Interface Descriptor */
       0x09,
       0x04,
       0x01,
       0x00,
       0x00,
       0x0e,
       0x02,
       0x00,
       0x08,
       /* VS Interface Input Header Descriptor */
       0x0e,
       0x24,
       0x01,
       0x01,
       0x51,
       0x00,
       0x81,
       0x00,
       0x02,
       0x00,
       0x00,
       0x00,
       0x01,
       0x00,
       /* Class-specific VS Format Descriptor----VS_FORMAT_UNCOMPRESSED */
       0x1b,
       0x24,
       0x04,
       0x01,
       0x01,
       0x59,
       0x55,
       0x59,
       0x32,
       0x00,
       0x00,
       0x10,
       0x00,
       0x80,
       0x00,
       0x00,
       0xaa,
       0x00,
       0x38,
       0x9b,
       0x71,
       0x10,
       0x01,
       0x00,
       0x00,
       0x00,
       0x00,
       /* 1920*1080@60fps */
       0x22,
       0x24,
       0x05,
       0x01,
       0x00,
       0x80,0x07,
       0x38,0x04,
       0x00,0x00,0xa7,0x76,
       0x00,0x00,0xa7,0x76,
       0x00,0x48,0x3f,0x00,
       0x0a,0x8b,0x02,0x00,
       0x02,
       0x0a,0x8b,0x02,0x00,
       0x15,0x16,0x05,0x00,
       /* Color Matching Descriptor */
       0x06,
       0x24,
       0x0d,
       0x01,
       0x01,
       0x04,

       0x09,0x04,0x01,0x01,0x01,0x0e,0x02,0x00,0x08,
       0x07,0x05,0x81,0x05,0x00,0x04,0x01,
       0x06,0x30,0x0b,0x02,0x00,0x90,

       0x09,0x04,0x01,0x02,0x01,0x0e,0x02,0x00,0x08,
       0x07,0x05,0x81,0x05,0x00,0x04,0x01,
       0x06,0x30,0x0e,0x00,0x00,0x3c,

       0x08,0x0b,0x02,0x02,0x01,0x02,0x00,0x09,

       0x09,
       0x04,
       0x02,
       0x00,
       0x00,
       0x01,
       0x01,
       0x00,
       0x09,

       0x09,
       0x24,
       0x01,
       0x00,
       0x01,
       0x26,
       0x00,
       0x01,
       0x03,

       0x0c,
       0x24,
       0x02,
       0x01,
       0x01,
       0x02,
       0x00,
       0x01,
       0x00,
       0x00,
       0x00,
       0x00,

       0x09,
       0x24,
       0x03,
       0x02,
       0x01,
       0x01,
       0x00,
       0x03,
       0x00,

       0x08,
       0x24,
       0x06,
       0x03,
       0x01,
       0x01,
       0x03,
       0x00,

       0x09,
       0x04,
       0x03,
       0x00,
       0x00,
       0x01,
       0x02,
       0x00,
       0x09,

       0x09,0x04,0x03,0x01,0x01,0x01,0x02,0x00,0x09,
       0x07,0x24,0x01,0x02,0x01,0x01,0x00,

       0x0b,0x24,0x02,0x01,0x02,0x02,0x10,0x01,0x80,0xbb,0x00,

       0x07,
       0x05,
       0x8a,
       0x05,
       0xc0,
       0x00,
       0x04,

       0x06,
       0x30,
       0x00,
       0x00,
       0xc0,
       0x00,

       0x07,
       0x25,
       0x01,
       0x01,
       0x00,
       0x00,
       0x00,
#endif

};

/******************************************************************************/
/* USB3.0ַ */
const UINT8 USB30_ManuInfo_Str_Desc_UVC[ ] =
{
    0x0E,
    0x03,
    'w', 0x00, 'c', 0x00, 'h', 0x00, '.', 0x00, 'c', 0x00, 'n', 0x00
};

/******************************************************************************/
/* USB3.0Ʒַ */
const UINT8 USB30_ProductInfo_Str_Desc_UVC[ ] =
{
    36,
    0x03,
    'W', 0x00, 'C', 0x00, 'H', 0x00, ' ', 0x00, 'U', 0x00, 'S', 0x00, 'B', 0x00, '3', 0x00,
    '.', 0x00, '0', 0x00, ' ', 0x00, 'C', 0x00, 'a', 0x00, 'm', 0x00, 'e', 0x00, 'r', 0x00,
    'a', 0x00
};

/******************************************************************************/
/* USB3.0кַ */
const UINT8 USB30_SerNumber_Str_Desc_UVC[ ] =
{
    0x16,
    0x03,
    '0', 0x00, '1', 0x00, '2', 0x00, '3', 0x00, '4', 0x00, '5', 0x00, '6', 0x00, '7', 0x00,
    '8', 0x00, '9', 0x00
};


/******************************************************************************/
/* ΪUVCس */
#define DEF_UVC_BURST_MAX          12                                           /* 趨ͻ */

#define DEF_UVC_PACK_MAX           48

#define DEF_NO_ERROR               0x00
#define DEF_NOT_READY              0x01
#define DEF_WRONG_STATE            0x02
#define DEF_POWER                  0x03
#define DEF_OUT_OF_RANGE           0x04
#define DEF_INVALID_UNIT           0x05
#define DEF_INVALID_CONTROL        0x06
#define DEF_INVALID_REQUEST        0x07
#define DEF_INVALID_WITHINRANGE    0x08
#define DEF_INVALID_UNKNOWN        0xFF

//ͨϢֵ
//wValue,Э鶨wIndexʾEntity ID
/*info
 * D0:1=Supports GET value requests                                             Capability
 * D1:1=Supports SET value requests                                                Capability
 * D2:1=Disabled due to automatic mode (under device control)       State
 * D3:1= Autoupdate Control                                                         Capability
 * D4:1= Asynchronous Control                                                           Capability
 * D5:1= Disabled due to incompatibility with Commit state.             State
 * D6-7:Reserved (Set to 0)
 * */
typedef struct
{
    UINT8 info[1];
    UINT8 len[2];   //չԪʹãʾǰֽֽͨǰ
    UINT8 min[10];
    UINT8 max[10];
    UINT8 res[10];
    UINT8 def[10];
    UINT8 cur[10];
    UINT8 set[10];
}Unit_t;

typedef struct __attribute__((packed))
{
    UINT8  Len;
    UINT8  Tog;
    UINT32 timeStamp;
    UINT32 sourceClock;
    UINT16 sofCounts;
}MJPEG_HEADER;

 UINT8V UVC_Set_Cur[ ]=
 {
    0x00, 0x00, 0x01, 0x01, 0x15, 0x16, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x48, 0x3F, 0x00, 0x00, 0x0C, 0x00, 0x00
 };

 UINT8V UVC_Get_Cur[ ] =
 {
    0x00, 0x00,
    0x01,
    0x01,
    0x0A, 0x8b, 0x02, 0x00,
    0x00, 0x00,
    0x00, 0x00,
    0x00, 0x00,
    0x00, 0x00,
    0x00, 0x00,
    0x00, 0x48, 0x3f, 0x00,
    0x0c, 0x87, 0x00, 0x00
 };

 volatile Unit_t VAICSID[ ] =
 {
    /*ID=0,͵VideoControl Interface Control Selectors */
    {
        0,{0},
        {0},{0},{0},{0},{0},{0}
    },//VC _CONTROL_ UNDEFINED
    {
        0,{0x01,0x00},
        {0},{0},{0},{0},{0x10},{0}
    },//VC_VIDEO_POWER_MODE_CONTROL
    {
        0,{0x01,0x00},
        {0},{0},{0},{0},{ DEF_NO_ERROR },{0}
    },//VC_REQUEST_ERROR_CODE_CONTROL
    {
    }//Reserved
 };

 volatile Unit_t CameraID[]={//ID 01
         {
                 0,{0},
                 {0},{0},{0},{0},{0},{0}
         },//CT_CONTROL_UNDEFINED 0
         {
                 0x03,{0x01,0x00},
                 {0},{0},{0},{0},{0},{0}

         },//CT_SCANNING_MODE_CONTROL 1
         {
                 0x03,{0x01,0x00},
                 {0},{0},{0},{0},{0x06},{0}
         },//CT_AE_MODE_CONTROL 2
         {
                 0x3,{0x01,0x00},
                 {0x00},{0x01},{0x01},{0x00},{0},{0}
         },//CT_AE_PRIORITY_CONTROL 3
         {
                 0x0f,{0x04,0x00},
                 {0x32,0x00,0x00,0x00},{0x10,0x27,0x00,0x00},{0x01,0x00,0x00,0x00},{0xa6,0x00,0x00,0x00},{0},{0}
         },//CT_EXPOSURE_TIME_ABSOLUTE_CONTROL 4
         {
                 0x00,{0x00,0x00},
                 {0},{0},{0},{0},{0},{0}
         },//CT_EXPOSURE_TIME_RELATIVE_CONTROL 5
         {
                 0x0f,{0x02,0x00},
                 {0x00,0x00},{0xff,0x03},{0x01,0x00},{0x44,0x00},{0x44,0x00},{0}
         },//CT_FOCUS_ABSOLUTE_CONTROL 6
         {
                 0x00,{0x00,0x00},
                 {0},{0},{0},{0},{0},{0}
         },//CT_FOCUS_RELATIVE_CONTROL 7
         {
                 0,{0x01},
                 {0},{0},{0},{0},{0x01},{0}
         },//CT_FOCUS_AUTO_CONTROL 8
         {
                0,{0},
                {0},{0},{0},{0},{0},{0}
         },//CT_IRIS_ABSOLUTE_CONTROL 9
         {
                 0,{0},
                 {0},{0},{0},{0},{0},{0}
         },//CT_IRIS_RELATIVE_CONTROL a
         {
                 0x03,{0x02,0x00},
                 {0x00,0x00},{0x03,0x00},{0x01,0x00},{0x00,0x00},{0},{0}
         },//CT_ZOOM_ABSOLUTE_CONTROL b
         {
                 0,{0},
                 {0},{0},{0},{0},{0},{0}
         },//CT_ZOOM_RELATIVE_CONTROL c
         {
                 0x03,{0x08,0x00},
                 {0x00, 0x1f, 0xff, 0xff,  0x40, 0x57, 0xff, 0xff },
                 {0x00, 0xe1, 0x00, 0x00,  0xc0, 0xa8, 0x00, 0x00},
                 {0x10, 0x0e, 0x00, 0x00,  0x10, 0x0e, 0x00, 0x00},{0x00, 0x00, 0x00, 0x00,  0x00, 0x00, 0x00, 0x00},{0},{0}
         },//CT_PANTILT_ABSOLUTE_CONTROL d
         {
                 0,{0},
                 {0},{0},{0},{0},{0},{0}
         },//CT_PANTILT_RELATIVE_CONTROL e
         {
                 0x03,{0x02,0x00},
                 {0},{0x03,0x00},{0x01,0x00},{0},{0},{0}
         },//CT_ROLL_ABSOLUTE_CONTROL f
         {
                 0x03,{0x02,0x00},
                 {0x00, 0x00},{0x03, 0x00},{0x01, 0x00},{0x00, 0x00},{0},{0}
         },//CT_ROLL_RELATIVE_CONTROL
         {
                 0,{0},
                 {0},{0},{0},{0},{0},{0}
         },//CT_PRIVACY_CONTROL
         {
                 0,{0},
                 {0},{0},{0},{0},{0},{0}
         },//CT_FOCUS_SIMPLE_CONTROL
         {
                 0,{0},
                 {0},{0},{0},{0},{0},{0}
         },//CT_WINDOW_CONTROL
         {
                 0,{0},
                 {0},{0},{0},{0},{0},{0}
         }//CT_REGION_OF_INTEREST_CONTROL
 };

 volatile Unit_t ProcessID[]={//ID 02
         {
                 0,{0x00,0x00},
                 {0},{0},{0},{0},{0},{0}
         },//PU_CONTROL_UNDEFINED 0
         {
                 0x03,{0x02,0x00},
                 {0x00, 0x00},{0x02, 0x00},{0x01, 0x00},{0x00, 0x00},{0},{0}
         },//PU_BACKLIGHT_COMPENSATION_CONTROL 1
         {
                 0x03,{0x02,0x00},
                 {0xc0, 0xff},{0x40, 0x00 },{0x01, 0x00},{0x00, 0x00},{0},{0}
         },//PU_BRIGHTNESS_CONTROL 2
         {
                 0x03,{0x02,0x00},
                 {0x00, 0x00},{0x64, 0x00},{0x01, 0x00 },{0x32, 0x00},{0},{0}
         },//PU_CONTRAST_CONTROL 3
         {
                 0,{0x00,0x00},
                 {0},{0},{0},{0},{0},{0}
         },//PU_GAIN_CONTROL 4
         {
                 0x03,{0x01,0x00},
                 {0x00},{0x02},{0x01},{0x01},{0x01},{0}
         },//PU_POWER_LINE_FREQUENCY_CONTROL 5
         {
                 0x03,{0x02,0x00},
                 {0x4c, 0xff},{ 0xb4, 0x00},{0x01, 0x00 },{0x00, 0x00},{0},{0}
         },//PU_HUE_CONTROL 6
         {
                 0x03,{0x02,0x00},
                 {0x00, 0x00},{0x64, 0x00},{0x01, 0x00},{0x40, 0x00},{0},{0}
         },//PU_SATURATION_CONTROL 7
         {
                 0x03,{0x02,0x00},
                 {0x00, 0x00},{0x64, 0x00},{0x01, 0x00},{0x32, 0x00},{0},{0}
         },//PU_SHARPNESS_CONTROL 8
         {
                 0x03,{0},
                 {0x64, 0x00},{0xf4, 0x01},{0x01, 0x00},{0x2c, 0x01},{0},{0}
         },//PU_GAMMA_CONTROL 9
         {
                 0x0f,{0x02,0x00},
                {0xf0, 0x0a},{0x64, 0x19},{0x0a, 0x00},{0xf8, 0x11},{0},{0}
         },//PU_WHITE_BALANCE_TEMPERATURE_CONTROL a
         {
                 0,{0},
                 {0},{0},{0},{0},{0},{0}
         },//PU_WHITE_BALANCE_TEMPERATURE_AUTO_CONTROL
         {
                 0,{0},
                 {0},{0},{0},{0},{0},{0}
         },//PU_WHITE_BALANCE_COMPONENT_CONTROL
         {
                 0,{0},
                 {0},{0},{0},{0},{0},{0}
         },//PU_WHITE_BALANCE_COMPONENT_AUTO_CONTROL
         {
                 0,{0},
                 {0},{0},{0},{0},{0},{0}
         },//PU_DIGITAL_MULTIPLIER_CONTROL
         {
                 0,{0},
                 {0},{0},{0},{0},{0},{0}
         },//PU_DIGITAL_MULTIPLIER_LIMIT_CONTROL
         {
                 0,{0},
                 {0},{0},{0},{0},{0},{0}
         },//PU_HUE_AUTO_CONTROL
         {
                 0,{0},
                 {0},{0},{0},{0},{0},{0}
         },//PU_ANALOG_VIDEO_STANDARD_CONTROL
         {
                 0,{0},
                 {0},{0},{0},{0},{0},{0}
         },//PU_ANALOG_LOCK_STATUS_CONTROL
         {
                 0,{0},
                 {0},{0},{0},{0},{0},{0}
         }//PU_CONTRAST_AUTO_CONTROL

 };
 volatile Unit_t ExtensionID1[]={//ID 04
         {0},{0},{0},{0},{0},{0},{0},{0},{0},{0},
         {
                 0x03,{0x08,0x00},
                 {0x00, 0x00, 0x00, 0x00,  0x00, 0x00, 0x00, 0x00},
                 {0xff, 0xff, 0xff, 0xff,  0xff, 0xff, 0xff, 0xff },
                 {0x01, 0x00, 0x00, 0x00,  0x00, 0x00, 0x00, 0x00},{0x00, 0x00, 0x00, 0x00,  0x00, 0x00, 0x00, 0x00},{0},{0}
         },//a
         {
                 0x03,{0x08,0x00},
                 {0x00, 0x00, 0x00, 0x00,  0x00, 0x00, 0x00, 0x00},
                 {0xff, 0xff, 0xff, 0xff,  0xff, 0xff, 0xff, 0xff },
                 {0x01, 0x00, 0x00, 0x00,  0x00, 0x00, 0x00, 0x00},{0x00, 0x00, 0x00, 0x00,  0x00, 0x00, 0x00, 0x00},{0},{0}
         }//b
 };
 volatile Unit_t ExtensionID2[]={//ID 06
         {0},
         {
                 0x03,{0x02,0x00},
                 {0x00, 0x00},{0xff, 0xff},{0x00, 0x00},{0x01, 0x00},{0},{0}
         },
         {
                 0x03,{0x02,0x00},
                 {0xfa, 0xff},{0x06, 0x00},{0x40, 0x00},{0x00, 0x00},{0},{0}
         },
         {
                 0x01,{0x02,0x00},
                 {0x00, 0x00},{0x00, 0x00},{0x00, 0x00},{0x00, 0x00},{0},{0}
         },
         {
                 0x03,{0x01,0x00},
                 {0x00, 0x00},{0x00, 0x00},{0x00, 0x00},{0x00, 0x00},{0},{0}
         },
         {
                 0x03,{0x01,0x00},
                {0x00, 0x00},{0x00, 0x00},{0x00, 0x00},{0x00, 0x00},{0},{0}
         },
         {
                 0x03,{0x01,0x00},
                 {0x00, 0x00},{0x00, 0x00},{0x00, 0x00},{0x00, 0x00},{0},{0}
         },{0},{0},{0},{0},{0},
         {0},{0},{0},{0},{0},{0},{0},
         {
                 0x03,{0x01,0x00},
                {0x00, 0x00},{0x01, 0x00},{0x01, 0x00},{0x00, 0x00},{0},{0}
         },
         {
                 0x03,{0x0a,0x00},
                 {0},{0x00, 0x00, 0x00, 0x00,  0x00, 0x00, 0x00, 0x00,  0x09, 0x00 },{0},{0},{0},{0}
         },
         {
                 0x01,{0x04,0x00},
                 {0},{0},{0},{0},{0},{0}
         },
         {
                 0x03,{0x01,0x00},
                 {0x00, 0x00},{0x01, 0x00},{0x01, 0x00},{0x00, 0x00},{0},{0}
         },
         {
                 0x03,{0x01,0x00},
                {0x01, 0x00},{0x03, 0x00},{0x02, 0x00},{0x01, 0x00},{0},{0}
         },
         {
                 0x03,{0x01,0x00},
                 {0x01, 0x00},{0x00, 0x00},{0x01, 0x00},{0x01, 0x00},{0},{0}
         }
 };

#ifdef __cplusplus
}
#endif

#endif
