/********************************** (C) COPYRIGHT *******************************
* File Name          : HSPI.C
* Author             : MJX
* Version            : V1.00
* Date               : 2021/07/15
* Description        : CH56xHSPIز
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include "MAIN.h"                                                               /* ͷļ */

/******************************************************************************/
/*  */
UINT32V HSPI_Tx_PackCnt = 0x00;											        /* HSPIͰ */
UINT32V HSPI_Rx_PackCnt = 0x00;											        /* HSPIհ */
UINT8V  HSPI_Int_En_Save = 0x00;                                                /* HSPIжʹܱ */

UINT32V HSPI_Tx_Data_LoadAddr = 0x00;                                           /* HSPIװַָ */
UINT32V HSPI_Tx_Data_DealAddr = 0x00;                                           /* HSPIݴַָ */
UINT32V HSPI_Tx_Data_RemainLen = 0x00;                                          /* HSPIʣ೤ */

UINT32V HSPI_Rx_Data_LoadAddr = 0x00;                                           /* HSPIװַָ */
UINT32V HSPI_Rx_Data_DealAddr = 0x00;                                           /* HSPIݴַָ */
UINT32V HSPI_Rx_Data_RemainLen = 0x00;                                          /* HSPIʣ೤ */
UINT8V  HSPI_Rx_Notice_Status = 0x00;                                           /* HSPI֪ͨ״̬ */

UINT8V  HSPI_Tx_Status = 0x00;                                                  /* HSPI״̬:0:; 1:ڷ; 2:;3:쳣; */
UINT8V  HSPI_Tx_BurstPackNum = 0x00;                                            /* HSPIͻ */
UINT16V HSPI_Tx_LastPackLen = 0x00;                                             /* HSPIͻĩβ */


/*******************************************************************************
* Function Name  : HSPI_GPIO_Init
* Description    : HSPIӿGPIOʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void HSPI_GPIO_Init( void )
{
    /* HTCLK(PA11)HTREQ(PA9)HTVLD(PA21)HTACK(PA10)Ϊ,Ϊ16mA */
    R32_PA_DIR |= ( ( 1 << 9 ) | ( 1 << 10 ) | ( 1 << 11 ) | ( 1 << 21 ) );
	R32_PA_DRV |= ( ( 1 << 11 ) );
	R32_PA_PU &= ~( ( 1 << 9 ) | ( 1 << 10 ) | ( 1 << 11 ) | ( 1 << 21 ) );
	R32_PA_PD &= ~( ( 1 << 9 ) | ( 1 << 10 ) | ( 1 << 11 ) | ( 1 << 21 ) );

    /* HTRDY(PA23)HRCLK(PA19)HRACK(PA18)HRVLD(PA6)Ϊ */
    R32_PA_DIR &= ~( ( 1 << 6 ) | ( 1 << 18 ) | ( 1 << 19 ) | ( 1 << 23 ) );
    R32_PA_PU &= ~( ( 1 << 6 ) | ( 1 << 18 ) | ( 1 << 19 ) | ( 1 << 23 ) );
    R32_PA_PD |= ( ( 1 << 6 ) | ( 1 << 18 ) | ( 1 << 19 ) | ( 1 << 23 ) );

    /*  HD0(PA6) HD1(PA4) HD2(PA22) HD3(PA3)  HD4(PA2)  HD5(PA1)  HD6(PA0)  HD7(PB21)
           HD8(PB20) HD9(PB19)HD10(PB18)HD11(PB17)HD12(PA17)HD13(PB16)HD14(PB15)HD15(PB14)
           HD16(PB0) HD17(PB1)HD18(PB2) HD19(PA20)HD20(PB3) HD21(PB4) HD22(PB5) HD23(PB6)
           HD24(PA16)HD25(PB7)HD26(PB8) HD27(PB9) HD28(PB10)HD29(PB11)HD30(PB12)HD31(PB13)Ϊ */
    R32_PA_DIR &= ~( ( 1 << 6 ) | ( 1 << 4 ) | ( 1 << 22 ) | ( 1 << 3 ) | ( 1 << 2 ) | ( 1 << 1 ) | ( 1 << 0 ) |
                     ( 1 << 17 ) | ( 1 << 20 ) | ( 1 << 16 ) );
    R32_PA_PU &= ~( ( 1 << 6 ) | ( 1 << 4 ) | ( 1 << 22 ) | ( 1 << 3 ) | ( 1 << 2 ) | ( 1 << 1 ) | ( 1 << 0 ) |
                    ( 1 << 17 ) | ( 1 << 20 ) | ( 1 << 16 ) );
    R32_PA_PD &= ~( ( 1 << 6 ) | ( 1 << 4 ) | ( 1 << 22 ) | ( 1 << 3 ) | ( 1 << 2 ) | ( 1 << 1 ) | ( 1 << 0 ) |
                    ( 1 << 17 ) | ( 1 << 20 ) | ( 1 << 16 ) );

    R32_PB_DIR &= 0xFFC00000;
    R32_PB_PU &= 0xFFC00000;
    R32_PB_PD &= 0xFFC00000;
}

/*******************************************************************************
* Function Name  : HSPI_Init
* Description    : HSPIӿڳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void HSPI_Init( void )
{
    UINT16 i;

	/* ùģʽ */
    R8_HSPI_CFG &= ~( RB_HSPI_MODE | RB_HSPI_MSK_SIZE );
#if( DEF_HSPI_MODE == DEF_HSPI_HOST_MODE )
       R8_HSPI_CFG |= RB_HSPI_MODE;
#else
    R8_HSPI_CFG &= ~( RB_HSPI_MODE );
#endif

    /* λ */
#if( DEF_HSPI_DATASIZE == DEF_HSPI_DATASIZE_8 )
	R8_HSPI_CFG |= RB_HSPI_DAT8_MOD;

#elif( DEF_HSPI_DATASIZE == DEF_HSPI_DATASIZE_16 )
	R8_HSPI_CFG |= RB_HSPI_DAT16_MOD;

#elif( DEF_HSPI_DATASIZE == DEF_HSPI_DATASIZE_32 )
	R8_HSPI_CFG |= RB_HSPI_DAT32_MOD;
#endif

    /* ACk mode 1(ӲԶӦģʽ ͻģʽ,ģʽ) */
	R8_HSPI_CFG |= RB_HSPI_HW_ACK;

    /* Tx ToG En */
    R8_HSPI_CFG |= RB_HSPI_TX_TOG_EN;

    /* Rx ToG En */
    R8_HSPI_CFG |= RB_HSPI_RX_TOG_EN;

    /* λʾ˫DMA,øλǰDMAٲ,ﵽٵЧ,32λģʽһҪд */
    R8_HSPI_AUX |= ( 1 << 5 );

	/* TX(½ز ) */
	R8_HSPI_AUX |= RB_HSPI_TCK_MOD;

	/* ӲAuto ACK time*/
	R8_HSPI_AUX |= RB_HSPI_ACK_TX_MOD;

	/* ʱʱ(ӳ2T) */
	R8_HSPI_AUX &= ~RB_HSPI_ACK_CNT_SEL;

    /* Clear ALL_CLR And TRX_RST */
	R8_HSPI_CTRL &= ~( RB_HSPI_ALL_CLR | RB_HSPI_TRX_RST );

    /* DMA TX/RX Addr0/1 */
	R32_HSPI_TX_ADDR0 = DEF_HPSI_DMA_TX_ADDR0;
	R32_HSPI_TX_ADDR1 = DEF_HPSI_DMA_TX_ADDR0 + DEF_HSPI_DMA_PACK_LEN;
    R32_HSPI_RX_ADDR0 = DEF_HPSI_DMA_RX_ADDR0;
	R32_HSPI_RX_ADDR1 = DEF_HPSI_DMA_RX_ADDR0 + DEF_HSPI_DMA_PACK_LEN;

    /* DMA TX/RX Len */
	R16_HSPI_DMA_LEN0 = DEF_HSPI_DMA_PACK_LEN - 1;
	R16_HSPI_DMA_LEN1 = DEF_HSPI_DMA_PACK_LEN - 1;

//	R16_HSPI_BURST_CFG |= (1<<8)|RB_HSPI_BURST_EN;
    if( ( R8_HSPI_RX_SC & RB_HSPI_RX_TOG ) == RB_HSPI_RX_TOG )
    {
        R8_HSPI_RX_SC = RB_HSPI_RX_TOG;
    }
    R8_HSPI_RX_SC = 0x00;
    if( ( R8_HSPI_TX_SC & RB_HSPI_TX_TOG ) == RB_HSPI_TX_TOG )
    {
        R8_HSPI_TX_SC = RB_HSPI_TX_TOG;
    }
    R8_HSPI_TX_SC = 0x00;

	/* Enable HSPI  DMA */
	R8_HSPI_CTRL |= RB_HSPI_ENABLE | RB_HSPI_DMA_EN;

    /*  TX Զ  Header */
    R32_HSPI_UDF0 = 0x00;
    R32_HSPI_UDF1 = 0x00;

    /* Enable Interupt */
    R8_HSPI_INT_EN |= RB_HSPI_IE_T_DONE;
    R8_HSPI_INT_EN |= RB_HSPI_IE_FIFO_OV;
    R8_HSPI_INT_EN |= RB_HSPI_IE_B_DONE;
    R8_HSPI_INT_EN |= RB_HSPI_IE_R_DONE;
    HSPI_Int_En_Save = R8_HSPI_INT_EN;
    R8_HSPI_INT_FLAG = 0x0F;

    PFIC_EnableIRQ( HSPI_IRQn );

    /* ʼر */
    HSPI_Tx_PackCnt = 0x00;
    HSPI_Rx_PackCnt = 0x00;

    HSPI_Tx_Data_LoadAddr = DEF_HPSI_DMA_TX_ADDR0;
    HSPI_Tx_Data_DealAddr = DEF_HPSI_DMA_TX_ADDR0;
    HSPI_Tx_Data_RemainLen = 0x00;

    HSPI_Rx_Data_LoadAddr = DEF_HPSI_DMA_RX_ADDR0;
    HSPI_Rx_Data_DealAddr = DEF_HPSI_DMA_RX_ADDR0;
    HSPI_Rx_Data_RemainLen = 0x00;

//#if( DEF_USB_MODE_UVC == 0x01 )
    for( i = 0; i < DEF_UVC_BUF_NUM; i++ )
    {
        UVC_BufInfo.Length[ i ] = 0x00;
    }
    UVC_BufInfo.LoadNum = 0x00;
    UVC_BufInfo.DealNum = 0x00;
    UVC_BufInfo.RemainCount = 0x00;
//#endif
}

/*******************************************************************************
* Function Name  : HSPI_IRQHandler
* Description    : HSPIӿжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void HSPI_IRQHandler (void) __attribute__((interrupt("WCH-Interrupt-fast")));
void HSPI_IRQHandler( void )
{
    UINT32V i, j;
    UINT32V addr;
   static  UINT32V len;

//    printf("h\n");

    if( R8_HSPI_INT_FLAG & RB_HSPI_IF_R_DONE )
	{
		/* ж */
		R8_HSPI_INT_FLAG = RB_HSPI_IF_R_DONE;  

	    /* ӻHRTS֪ͨͣһݷ */
	    PIN_HRTS_HIGH( );

		/* жCRCǷȷжϰǷƥ */
        if( R8_HSPI_RTX_STATUS == 0x00 )
        {
            /* CRCȷкƥ */

            /* رл */
            HSPI_Rx_PackCnt++;
            if( HSPI_Rx_PackCnt % 2 )
            {
                R32_HSPI_RX_ADDR0 += ( DEF_HSPI_DMA_PACK_LEN * 2 );
            }
            else
            {
                R32_HSPI_RX_ADDR1 += ( DEF_HSPI_DMA_PACK_LEN * 2 );
            }

            /* ͬģʽ */
            /* жǷյĩβ */
            if( ( R32_HSPI_UDF0 & ( 1 << 13 ) ) || ( R32_HSPI_UDF1 & ( 1 << 13 ) ) )
            {
                /* ر */
//                printf("l1:%08x",R32_HSPI_UDF1);
                len = ( HSPI_Rx_PackCnt - 1 ) * DEF_HSPI_DMA_PACK_LEN;
                if( R32_HSPI_UDF0 & ( 1 << 13 ) )
                {
                    len += ( R32_HSPI_UDF0 & 0x00000FFF );
                    if( ( R32_HSPI_UDF0 & 0x00000FFF ) == 0x00 )
                    {
                        len += DEF_HSPI_DMA_PACK_LEN;
                    }
                }
                else if( R32_HSPI_UDF1 & ( 1 << 13 ) )
                {
                    len += ( R32_HSPI_UDF1 & 0x00000FFF );
                    if( ( R32_HSPI_UDF1 & 0x00000FFF ) == 0x00 )
                    {
                        len += DEF_HSPI_DMA_PACK_LEN;
                    }
                }
                UVC_BufInfo.Length[ UVC_BufInfo.LoadNum ] = len;
                UVC_BufInfo.FullFlag[ UVC_BufInfo.LoadNum ] = 0x00;
#if 0
                /* ݲ */
                addr = DEF_HPSI_DMA_RX_ADDR0 + ( UVC_BufInfo.LoadNum * DEF_HSPI_UVC_BPACK_LEN );
                for( i = 0; i < 12; i++ )
                {
                   printf("%lx ",(UINT32)*(UINT32 *)(addr + i*12));
                }
                printf("\n");
#endif
                if(( R32_HSPI_UDF0 & ( 1 << 14 ) ) || ( R32_HSPI_UDF1 & ( 1 << 14 ) ))           /*жһ֡Ƿ*/
                {
                    UVC_BufInfo.FullFlag[ UVC_BufInfo.LoadNum ] = 0x01;
                }
                UVC_BufInfo.RemainCount++;
                /* DMAַر */
                UVC_BufInfo.LoadNum++;
                if( UVC_BufInfo.LoadNum >= DEF_UVC_BUF_NUM )
                {
                    UVC_BufInfo.LoadNum = 0x00;
                }
                addr = DEF_HPSI_DMA_RX_ADDR0 + ( UVC_BufInfo.LoadNum * (DEF_HSPI_UVC_BPACK_LEN-3840) );
                R32_HSPI_RX_ADDR0 = addr;
                R32_HSPI_RX_ADDR1 = addr + DEF_HSPI_DMA_PACK_LEN;

                /* ն˳CRCMIS,ҪRB_HSPI_RX_NUM */
                if( ( R8_HSPI_RX_SC & RB_HSPI_RX_TOG ) == RB_HSPI_RX_TOG )
                {
                    R8_HSPI_RX_SC = RB_HSPI_RX_TOG;
                }
                R8_HSPI_RX_SC = 0x00;
                HSPI_Rx_PackCnt = 0x00;

                /* ԶĴ */
                R32_HSPI_UDF0 = 0x00;
                R32_HSPI_UDF1 = 0x00;
                /* HSPI֪ͨ״̬ */
                HSPI_Rx_Notice_Status = 0x01;
            }
            else if( HSPI_Rx_PackCnt >= DEF_HSPI_UVC_BPACK_NUM )
            {
                /* ر */
                UVC_BufInfo.Length[ UVC_BufInfo.LoadNum ] = DEF_HSPI_UVC_BPACK_LEN-3840;
                UVC_BufInfo.FullFlag[ UVC_BufInfo.LoadNum ] = 0x00;
                UVC_BufInfo.RemainCount++;

                /* DMAַر */
                UVC_BufInfo.LoadNum++;
                if( UVC_BufInfo.LoadNum >= DEF_UVC_BUF_NUM )
                {
                    UVC_BufInfo.LoadNum = 0x00;
                }
                addr = DEF_HPSI_DMA_RX_ADDR0 + ( UVC_BufInfo.LoadNum * (DEF_HSPI_UVC_BPACK_LEN-3840));
                R32_HSPI_RX_ADDR0 = addr;
                R32_HSPI_RX_ADDR1 = addr + DEF_HSPI_DMA_PACK_LEN;

                /* ն˳CRCMIS,ҪRB_HSPI_RX_NUM */
                if( ( R8_HSPI_RX_SC & RB_HSPI_RX_TOG ) == RB_HSPI_RX_TOG )
                {
                    R8_HSPI_RX_SC = RB_HSPI_RX_TOG;
                }
                R8_HSPI_RX_SC = 0x00;
                HSPI_Rx_PackCnt = 0x00;

                /* HSPI֪ͨ״̬ */
                HSPI_Rx_Notice_Status = 0x01;
            }
        }
        else if( R8_HSPI_RTX_STATUS & RB_HSPI_CRC_ERR )
		{
			/* CRCУ */
			DUG_PRINTF("CRC Err: %d\r\n",(UINT16)HSPI_Rx_PackCnt);
			DUG_PRINTF("R8_HSPI_RX_SC:%d\r\n",R8_HSPI_RX_SC);

			/* DMAַر */
            R32_HSPI_RX_ADDR0 = DEF_HPSI_DMA_RX_ADDR0;
            R32_HSPI_RX_ADDR1 = DEF_HPSI_DMA_RX_ADDR0 + DEF_HSPI_DMA_PACK_LEN;
            if( ( R8_HSPI_RX_SC & RB_HSPI_RX_TOG ) == RB_HSPI_RX_TOG )
            {
                R8_HSPI_RX_SC = RB_HSPI_RX_TOG;
            }

            /* ն˳CRCMIS,ҪRB_HSPI_RX_NUM */
            R8_HSPI_RX_SC = 0x00;
            HSPI_Rx_PackCnt = 0x00;
        }
		else if( R8_HSPI_RTX_STATUS & RB_HSPI_NUM_MIS )
		{
			/* кŲƥ */
            DUG_PRINTF("NUM_MIS Err: %d\r\n",(UINT16)HSPI_Rx_PackCnt);
            DUG_PRINTF("R8_HSPI_RX_SC:%d\r\n",R8_HSPI_RX_SC);

			/* DMAַر */
            R32_HSPI_RX_ADDR0 = DEF_HPSI_DMA_RX_ADDR0;
            R32_HSPI_RX_ADDR1 = DEF_HPSI_DMA_RX_ADDR0 + DEF_HSPI_DMA_PACK_LEN;
            if( ( R8_HSPI_RX_SC & RB_HSPI_RX_TOG ) == RB_HSPI_RX_TOG )
            {
                R8_HSPI_RX_SC = RB_HSPI_RX_TOG;
            }

            /* ն˳CRCMIS,ҪRB_HSPI_RX_NUM */
            R8_HSPI_RX_SC = 0x00;
            HSPI_Rx_PackCnt = 0x00;
        }
	}
    else if( R8_HSPI_INT_FLAG & RB_HSPI_IF_T_DONE )
    {
        /* ж */
        R8_HSPI_INT_FLAG = RB_HSPI_IF_T_DONE;

        /* رл */
        HSPI_Tx_PackCnt++;
        if( HSPI_Tx_PackCnt % 2 )
        {
            R32_HSPI_TX_ADDR0 += ( DEF_HSPI_DMA_PACK_LEN * 2 );
        }
        else
        {
            R32_HSPI_TX_ADDR1 += ( DEF_HSPI_DMA_PACK_LEN * 2 );
        }

        /* жϵǰǷĩβ */
        if( ( HSPI_Tx_BurstPackNum < DEF_HSPI_BULK_BPACK_NUM ) && ( HSPI_Tx_PackCnt == ( HSPI_Tx_BurstPackNum - 2 ) ) )
        {
            len = HSPI_Tx_LastPackLen % 1024;
            R32_HSPI_UDF0 = len | ( 1 << 13 );
            R32_HSPI_UDF1 = len | ( 1 << 13 );
        }
    }
    else if( R8_HSPI_INT_FLAG & RB_HSPI_IF_B_DONE )
    {
		/* ͻģʽ,ͻа */
        R8_HSPI_INT_FLAG = RB_HSPI_IF_B_DONE;

		/* ȽʵʷͰõͻǷһ */
		if( HSPI_Tx_PackCnt != ( R16_HSPI_BURST_CFG >> 8 ) )
		{
            printf("BURST Tx Err:%d\r\n",HSPI_Tx_PackCnt);

            /* DMAַر */
//          R32_HSPI_TX_ADDR0 = DEF_HPSI_DMA_TX_ADDR0;
//          R32_HSPI_TX_ADDR1 = DEF_HPSI_DMA_TX_ADDR0 + DEF_HSPI_DMA_PACK_LEN;
            if( ( R8_HSPI_TX_SC & RB_HSPI_TX_TOG ) == RB_HSPI_TX_TOG )
            {
                R8_HSPI_TX_SC = RB_HSPI_TX_TOG;
            }
            R8_HSPI_TX_SC = 0x00;
            HSPI_Tx_PackCnt = 0x00;

            /* HSPI״̬ */
			HSPI_Tx_Status = 0x00;

            /* жǷԼз */
            if( ( PIN_HCTS_RD( ) == 0x00 ) && ( HSPI_Rx_PackCnt == 0x00 ) )
            {
                HSPI_Tx_Data_Deal( );
            }
		}
		else
		{
	        /* DMAַر */
//	        R32_HSPI_TX_ADDR0 = DEF_HPSI_DMA_TX_ADDR0;
//	        R32_HSPI_TX_ADDR1 = DEF_HPSI_DMA_TX_ADDR0 + DEF_HSPI_DMA_PACK_LEN;
	        if( ( R8_HSPI_TX_SC & RB_HSPI_TX_TOG ) == RB_HSPI_TX_TOG )
	        {
	            R8_HSPI_TX_SC = RB_HSPI_TX_TOG;
	        }
	        R8_HSPI_TX_SC = 0x00;
	        HSPI_Tx_PackCnt = 0x00;

            /* HSPI״̬ */
            HSPI_Tx_Status = 0x00;

	        /* δ͵ʣ೤ */
	        HSPI_Tx_Data_RemainLen -= HSPI_Tx_LastPackLen;

	        /* : 㷢͵HSPIܳ */
#if( DEF_FUN_DEBUG_EN == 0x01 )
	        Dbg_HSPI_Tx_TLen += ( HSPI_Tx_LastPackLen );
#endif

	        /* һη͵HSPIַ */
	        HSPI_Tx_Data_DealAddr += ( HSPI_Tx_BurstPackNum * DEF_HSPI_DMA_PACK_LEN );
	        if( HSPI_Tx_Data_DealAddr >= DEF_HPSI_TX_DMA_ADDR_MAX )
	        {
	            HSPI_Tx_Data_DealAddr = DEF_HPSI_DMA_TX_ADDR0;
	        }

	        /* жǷԼз */
	        if( ( PIN_HCTS_RD( ) == 0x00 ) && ( HSPI_Rx_PackCnt == 0x00 ) )
	        {
	            HSPI_Tx_Data_Deal( );
	        }
		}
    }
	else if( R8_HSPI_INT_FLAG & RB_HSPI_IF_FIFO_OV )
	{
		/* FIFOж */
		R8_HSPI_INT_FLAG = RB_HSPI_IF_FIFO_OV;
		printf("FIFO OV\r\n");
	}

#if( DEF_FUN_DEBUG_EN == 0x01 )
    Dbg_Idle_TimeCount = 0;
#endif
}

/*******************************************************************************
* Function Name  : HSPI_Tx_Data_Deal
* Description    : HSPIӿڷݴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void HSPI_Tx_Data_Deal( void )
{
    UINT32V remanlen;
    UINT32V len;
    UINT32V packlen;
    UINT32V i;

    /* жǷҪͨHSPIз */
    remanlen = HSPI_Tx_Data_RemainLen;
    if( remanlen )
    {
        /* 㱾η͵ͻĩβ */
        if( remanlen >= DEF_HSPI_BULK_BPACK_LEN )
        {
            packlen = DEF_HSPI_BULK_BPACK_LEN;

            /* жϻƫǷ㹻෢͵ĩβ */
            if( packlen > ( DEF_HPSI_TX_DMA_ADDR_MAX - HSPI_Tx_Data_DealAddr ) )
            {
                packlen = ( DEF_HPSI_TX_DMA_ADDR_MAX - HSPI_Tx_Data_DealAddr );
            }
        }
        else
        {
            /* жǷﵽʱʱ */
            if( Endp1_Down_IdleCount >= DEF_USB_DOWN_IDLE_TIMEOUT )
            {
                Endp1_Down_IdleCount = 0x00;

                packlen = remanlen;

                /* жϻƫǷ㹻෢͵ĩβ */
                if( packlen > ( DEF_HPSI_TX_DMA_ADDR_MAX - HSPI_Tx_Data_DealAddr ) )
                {
                    packlen = ( DEF_HPSI_TX_DMA_ADDR_MAX - HSPI_Tx_Data_DealAddr );
                }
            }
            else
            {
                packlen = 0x00;
            }
        }

        /* ͻģʽݷ */
        if( packlen )
        {
            HSPI_Tx_LastPackLen = packlen;
            HSPI_Tx_BurstPackNum = ( HSPI_Tx_LastPackLen + ( DEF_HSPI_DMA_PACK_LEN - 1 ) ) / DEF_HSPI_DMA_PACK_LEN;

            /* ֻ2ǰдԶĴ֪ͨԷ
                                        2ҪϷʱдԶĴ֪ͨԷ; */
            if( HSPI_Tx_BurstPackNum > 2 )
            {
                R32_HSPI_UDF0 = DEF_HSPI_DMA_PACK_LEN;
                R32_HSPI_UDF1 = DEF_HSPI_DMA_PACK_LEN;
            }
            else if( HSPI_Tx_BurstPackNum == 1 )
            {
                len = HSPI_Tx_LastPackLen % 1024;
                R32_HSPI_UDF0 = len | ( 1 << 13 );
            }
            else if( HSPI_Tx_BurstPackNum == 2 )
            {
                len = HSPI_Tx_LastPackLen % 1024;
                R32_HSPI_UDF1 = len | ( 1 << 13 );
            }

            /* ر */
            HSPI_Tx_PackCnt = 0x00;
            HSPI_Tx_Status = 0x01;

            /* HSPIݷ */
            R32_HSPI_TX_ADDR0 = HSPI_Tx_Data_DealAddr;
            R32_HSPI_TX_ADDR1 = HSPI_Tx_Data_DealAddr + DEF_HSPI_DMA_PACK_LEN;
            R16_HSPI_BURST_CFG = ( HSPI_Tx_BurstPackNum << 8 ) | RB_HSPI_BURST_EN;
            R8_HSPI_INT_FLAG = RB_HSPI_IF_T_DONE | RB_HSPI_IF_B_DONE;           /* ֮ǰHSPIжϱ־0 */
            R8_HSPI_CTRL |= RB_HSPI_SW_ACT;                                     /*  */
        }
    }
}




