/********************************** (C) COPYRIGHT *******************************
* File Name          : MAIN.H
* Author             : MJX
* Version            : V1.00
* Date               : 2021/07/10
* Description        : ļͷļ
*******************************************************************************/



#ifndef __MAIN_H__
#define __MAIN_H__

#ifdef __cplusplus
extern "C" {
#endif

/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>													
#include "string.h"
#include "PRINTF.h"									                			/* ڵԴӡͷļ */
#include "TYPE.h"										                		/* Ͷͷļ */
#include "HAL.h"                                                                /* Ӳͷļ */
#include "CH56x_common.h"                                                       /* CH56xͨöͷļ */
#include "CH56x_usb20.h"                                                        /* CH56x USB2.0ͷļ */
#include "CH56x_usb30.h"                                                        /* CH56x USB3.0ͷļ */
#include "CH56x_usb30_LIB.h"
//#include "usb30_reg.h"
#include "HSPI.h"                                                               /* CH56xӲHSPIͷļ */

/*******************************************************************************/
/* ģӲ汾 */
#define DEF_PROG_VERSION  	   	   0x01											/* 汾 */

/*******************************************************************************/
/* USBģʽ(ͬһʱֻʹһģʽ) */
#define DEF_USB_MODE_BULK          0x00                                         /* ģʽ */
#define DEF_USB_MODE_UVC           0x01                                         /* UVCģʽ */

/*******************************************************************************/
/* XRAM ض */

/* USBRAMַ */
#define DEF_ENDP0_DMA_ADDR         ( 0x20020000 )                                   /* USB˵0DMAַ */
#define DEF_ENDP0_BUF_LEN          2048                                             /* USB˵0С */
#define DEF_ENDP2_TX_DMA_ADDR      ( DEF_ENDP0_DMA_ADDR + DEF_ENDP0_BUF_LEN )       /* USB˵2DMAַ */
#define DEF_ENDP2_TX_BUF_LEN       1024                                             /* USB˵2ͻС */
#define DEF_ENDP2_RX_DMA_ADDR      ( DEF_ENDP2_TX_DMA_ADDR + DEF_ENDP2_TX_BUF_LEN ) /* USB˵2DMAַ */
#define DEF_ENDP2_RX_BUF_LEN       1024                                             /* USB˵2ջС */
#define DEF_ENDP3_TX_DMA_ADDR      ( DEF_ENDP2_RX_DMA_ADDR + DEF_ENDP2_RX_BUF_LEN ) /* USB˵3DMAַ */
#define DEF_ENDP3_TX_BUF_LEN       1024                                             /* USB˵3ͻС */
#define DEF_ENDP3_RX_DMA_ADDR      ( DEF_ENDP3_TX_DMA_ADDR + DEF_ENDP3_TX_BUF_LEN ) /* USB˵3DMAַ */
#define DEF_ENDP3_RX_BUF_LEN       1024                                             /* USB˵3ջС */
#define DEF_ENDP1_TX_DMA_ADDR      ( DEF_ENDP3_RX_DMA_ADDR + DEF_ENDP3_RX_BUF_LEN ) /* USB˵1DMAַ */
#define DEF_ENDP1_TX_BUF_LEN_BULK  ( 48 * 1024 )                                    /* USB˵1ͻС */
#define DEF_ENDP1_TX_BUF_LEN_UVC   ( DEF_HSPI_UVC_BPACK_LEN*2 )                                    /* USB˵1ͻС */
#define DEF_ENDP1_RX_DMA_ADDR      ( DEF_ENDP1_TX_DMA_ADDR + DEF_ENDP1_TX_BUF_LEN_BULK ) /* USB˵1DMAַ */
#define DEF_ENDP1_RX_BUF_LEN       ( 32 * 1024 )                                    /* USB˵1ջС */

/* HSPIRAMַ */
#define DEF_HPSI_DMA_TX_ADDR0      DEF_ENDP1_RX_DMA_ADDR                            /* HSPIDMA0ַ */
#define DEF_HPSI_DMA_RX_ADDR0      DEF_ENDP1_TX_DMA_ADDR                            /* HSPIDMA0ַ */

#define DEF_HPSI_TX_DMA_ADDR_MAX   ( DEF_HPSI_DMA_TX_ADDR0 + DEF_ENDP1_RX_BUF_LEN ) /* HSPIݷDMAַ */
#define DEF_HPSI_RX_DMA_ADDR_MAX   ( DEF_HPSI_DMA_RX_ADDR0 + DEF_ENDP1_TX_BUF_LEN_BULK ) /* HSPIݽDMAַ */

/*******************************************************************************/
/* ʹغ궨 */
#define DEF_FUN_DEBUG_EN           0x00                                         /* Թʹ */

/*******************************************************************************/
/* غ궨 */
#define DEF_USB_DOWN_IDLE_TIMEOUT  500                                          /* USB´ʱ䶨 */
#define YUV_FRAME_SIZE             (1920*1080*2)
#define UVC_MICROFRAME_SIZE        (1920*18)
#define UVC_FRAME_RATE             (60)
/* UVC */
#define DEF_UVC_BUF_NUM      ( DEF_ENDP1_TX_BUF_LEN_UVC / DEF_HSPI_UVC_BPACK_LEN )/* UVCݻ(ÿռ16K) */
typedef struct __attribute__((packed))
{
    UINT32 Length[ DEF_UVC_BUF_NUM ];                                           /* UVCЧݳ */
    UINT8  FullFlag[ DEF_UVC_BUF_NUM ];                                         /* UVC־01 */
    UINT8  LoadNum;                                                             /* UVCװر */
    UINT8  DealNum;                                                             /* UVC */
    UINT8  RemainCount;                                                         /* UVCʣ */
}UVC_BUF_INFO;

/******************************************************************************/
/*  */

/* Ϊر */
extern UINT32V Dbg_Idle_TimeCount;
extern UINT64V Dbg_HSPI_Tx_TLen;
extern UINT64V Dbg_HSPI_Rx_TLen;
extern UINT64V Dbg_USB_Up_TLen;
extern UINT64V Dbg_USB_Down_TLen;

extern volatile UVC_BUF_INFO UVC_BufInfo;                                       /* UVCϢؽṹ */

/********************************************************************************/
/*  */

#ifdef __cplusplus
}
#endif

#endif

/*********************************END OF FILE**********************************/
